-- This example illustrates how to extend set of printf escape
-- codes available in standard SCIENTIFIC_FORMAT.
--
-- Here  we add  !v  typechar that print  a  vector of  reals.
-- Format specificators  such as width, precision or alignment
-- applied to every element of vector.
--
-- 1).  To  do this, you should create  class  inherited  from
-- ABSTRACT_FORMATTER and redefine callback methods - that set
-- width, precision, etc for you object (See vect_fmt.e)
--
-- 2) Next   you   should   create   class   inherited    from
-- SCIENTIFIC_FORMAT   and   redefine   only  one  methods   -
-- formatters, that  create  table  of  available  for  printf
-- typechars. Add you  own typechar class to defaut table (See
-- ext_form.e).
--
-- That's all!   In this class we demonstrate how it works.

indexing

   title:       "EXT_SCIENTIFIC_FORMAT usage example";
   cluster:     "";
   project:     "FORMAT";
   copyright:   "(C) Frieder Monninger & Alexei Shestialtynov, 1995";
   author:      "Andy Malakov  (andy@eiffel.ru) and";
   original:    12,Sept,1995;
   version:     1.0;
   last_change:
   approved_by:
   approved:
   done_at:     "SiG Computer Inc. Moscow (info@eiffel.ru)";
   extrnl_name: "binary.e"

class BINARY
   -- Class illustrate SCIENTIFIC_FORMAT usage.

inherit
   EXT_SCIENTIFIC_FORMAT
      rename make as sformat_make
      end

creation
   make

feature

   make is
   local
      i : INTEGER
   do
      sformat_make

      printf ( "Binary numbers !z !z !z !z !z !z%N", <<0,1,2,3,4,5>> )

   end -- make

end -- class VECTOR

