indexing

   title:       "Additional math service";
   cluster:     "format/science [format/science]";
   project:     "The Universal Simple Formatting Library (USFL)";
   copyright:   "SIG Computer, 1995";
   author:      "Igor Nesterof (nest@eiffel.ru)";
   original:    08,Sep,1995;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   extrnl_name: "ext_math.e"

class EXTENDED_MATH

inherit
   MATH

feature

------------------------------------------------------------int_abs
   int_abs(i : INTEGER) : INTEGER is
   do
      if i >= 0 then
         Result :=  i
      else
         Result := -i
      end
   end

------------------------------------------------------------real_sign
   real_sign(r : REAL) : INTEGER is
   do
      if r > 0.0 then
         Result :=  1
      elseif r = 0.0 then
         Result := 0
      else
         Result := -1
      end
   end

------------------------------------------------------------int_sign
   int_sign(i : INTEGER) : INTEGER is
   do
      if i > 0 then
         Result :=  1
      elseif i = 0 then
         Result := 0
      else
         Result := -1
      end
   end

------------------------------------------------------------log10
   log10(x : REAL): REAL is
   do
      Result := log(x)/log(10)
   end

------------------------------------------------------------ten_power
   ten_power(x : INTEGER):REAL is
   local
      i : INTEGER
      sign : INTEGER
      r : REAL
   do
      if x < 0 then
         Result := 1 / (10.0^(-x))
      else
         Result := 10.0^x
      end
   end

end -- class EXTENDED_MATH
