indexing

   title:       "Optimal float pont formatter as g type in C";
   cluster:     "format/science [format/science]";
   project:     "The Universal Simple Formatting Library (USFL)";
   copyright:   "SIG Computer, 1995";
   author:      "Igor Nesterof (nest@eiffel.ru)";
   original:    08,Sep,1995;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   extrnl_name: "real_fmt.e"

class REAL_FORMATTER

inherit
   ABSTRACT_FORMATTER
      redefine
         make, set_width, set_precision, set_align_left, set_align_right,
         set_align_char, set_align_center, set_sign, output
      end
   EXTENDED_MATH

creation
   make

feature

   fl_f : FLOAT_POINT_FORMATTER
   fx_f : FIXED_POINT_FORMATTER

   make(r : REAL_REF) is
   require else
      format_real : r /= Void
   do
      abstract_make(r.item)
      !!fl_f.make(r)
      !!fx_f.make(r)
      fl_f.set_zero_strip(true)
      fx_f.set_zero_strip(true)
   end

   set_width(w:INTEGER) is
   do
      fl_f.set_width(w)
      fx_f.set_width(w)
   end

   set_precision(p:INTEGER) is
   do
      fl_f.set_precision(p)
      fx_f.set_precision(p)
   end

   set_sign(s:CHARACTER) is
   do
      fl_f.set_sign(s)
      fx_f.set_sign(s)
   end

   set_align_left is
   do
      fl_f.set_align_left
      fx_f.set_align_left
   end

   set_align_right is
   do
      fl_f.set_align_right
      fx_f.set_align_right
   end

   set_align_center is
   do
      fl_f.set_align_center
      fx_f.set_align_center
   end

   set_align_char(c:CHARACTER) is
   do
      fl_f.set_align_char(c)
      fx_f.set_align_char(c)
   end

   output : STRING is
   local
      f : REAL
      i : INTEGER
      sap : INTEGER
   do
      if fl_f.exponent < -4 or else fl_f.exponent >= fl_f.prec then
         fl_f.set_precision(fl_f.prec-1)
         Result := fl_f.output
      else
         -- significant after point
         sap := fx_f.prec-fl_f.exponent-1
         if sap <= 0 then
            fx_f.set_precision(0)
         else
            fx_f.set_precision(fx_f.prec-fl_f.exponent-1)
         end
         Result := fx_f.output
      end
   end

end -- class REAL_FORMATTER
